"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const constant_1 = require("../config/constant");
const aspectoConfig_1 = __importDefault(require("../config/aspectoConfig"));
const dynamic_require_1 = require("../utils/dynamic-require");
class GITCollector {
    interval() {
        return constant_1.MetadataCollectionInterval;
    }
    collect() {
        try {
            const readFileSync = dynamic_require_1.fs().readFileSync;
            const rootPath = aspectoConfig_1.default.getLinkedRootFolder();
            const rev = readFileSync(`${rootPath}.git/HEAD`)
                .toString()
                .trim();
            if (rev.indexOf(':') === -1) {
                GITCollector.hash = rev;
                return rev;
            }
            else {
                let hash = readFileSync(`${rootPath}.git/${rev.substring(5).replace('\n', '')}`)
                    .toString()
                    .replace('\n', '')
                    .trim();
                GITCollector.hash = hash;
                return hash;
            }
        }
        catch (e1) {
            // console.log('e1', e1);
        }
        try {
            const gitData = dynamic_require_1.child_process()
                .execSync('git rev-parse HEAD', { stdio: 'ignore' })
                .toString()
                .trim();
            GITCollector.hash = gitData;
            return gitData;
        }
        catch (e2) {
            // console.log('e2', e2);
        }
        try {
            const gitData = dynamic_require_1.child_process()
                .execSync('git rev-parse HEAD', { stdio: 'ignore' })
                .toString()
                .trim();
            GITCollector.hash = gitData;
            return gitData;
        }
        catch (e3) {
            // console.log('e3', e3);
        }
        const id = aspectoConfig_1.default.getNPMPostInstallId();
        GITCollector.hash = id;
        return id;
    }
    getKey() {
        return 'GIT_COLLECTION';
    }
}
exports.default = GITCollector;
//# sourceMappingURL=GitCollector.js.map