"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const socketIo = __importStar(require("socket.io-client"));
class WebSocketConnection {
    constructor(host) {
        this.host = host;
    }
    auth(token) {
        this.token = token;
        return new Promise((resolve, reject) => {
            try {
                this.socket = socketIo.connect(this.host, {
                    query: { token: token },
                    transports: ['websocket'],
                });
                this.socket.on('connect', function () {
                    this.token = token;
                    resolve(true);
                });
                this.socket.on('error', function (_err) {
                    reject();
                });
            }
            catch (error) {
                reject();
            }
        });
    }
    send(data) {
        data.token = this.token;
        let stringData = JSON.stringify(data);
        this.socket.send(stringData);
    }
    emit(event, ...args) {
        this.socket.emit(event, ...args);
    }
    on(event, cb) {
        this.socket.on(event, cb);
    }
    close() {
        this.socket.close();
    }
}
exports.default = WebSocketConnection;
//# sourceMappingURL=ws.js.map