"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const aspectoConfig_1 = __importDefault(require("./aspectoConfig"));
const shouldIgnoreByCliHeader = (headers) => {
    if (headers) {
        const xOriginHeader = Object.entries(headers).find(([key, _value]) => key.toLowerCase() === 'x-origin');
        if (xOriginHeader && typeof xOriginHeader[1] === 'string' && xOriginHeader[1].toLowerCase() === 'aspecto-cli')
            return true;
    }
    return false;
};
const hasOneWithMatchingRegex = (regex, value) => (regex || []).some((x) => new RegExp(x).test(value));
const match = (message) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    return shouldIgnoreByCliHeader((_b = (_a = message) === null || _a === void 0 ? void 0 : _a.HTTP_REQUEST) === null || _b === void 0 ? void 0 : _b.requestHeaders) ||
        hasOneWithMatchingRegex((_d = (_c = aspectoConfig_1.default) === null || _c === void 0 ? void 0 : _c.blacklist) === null || _d === void 0 ? void 0 : _d.hostname, (_f = (_e = message) === null || _e === void 0 ? void 0 : _e.HTTP_REQUEST) === null || _f === void 0 ? void 0 : _f.hostname) ||
        hasOneWithMatchingRegex((_h = (_g = aspectoConfig_1.default) === null || _g === void 0 ? void 0 : _g.blacklist) === null || _h === void 0 ? void 0 : _h.route, (_l = (_k = (_j = message) === null || _j === void 0 ? void 0 : _j.HTTP_REQUEST) === null || _k === void 0 ? void 0 : _k.route) === null || _l === void 0 ? void 0 : _l.path);
};
exports.default = { match };
//# sourceMappingURL=BlacklistMatcher.js.map