"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ws_1 = __importDefault(require("../communication/ws"));
const config_1 = require("../config");
const deferred_1 = require("../utils/deferred");
class ConfigService {
    constructor() {
        this.initialized = false;
        this.configDef = new deferred_1.Deferred();
    }
    get isInitialized() {
        return this.initialized;
    }
    init({ token, host }) {
        return __awaiter(this, void 0, void 0, function* () {
            this.conn = new ws_1.default(host || config_1.ConfigHost);
            yield this.conn.auth(token);
            this.conn.on('config', (config) => {
                this.configDef.resolve(config);
                this.initialized = true;
            });
            this.conn.emit('get-config');
        });
    }
    get config() {
        return this.configDef.promise;
    }
    close() {
        this.conn.close();
    }
}
exports.default = new ConfigService();
//# sourceMappingURL=ConfigService.js.map