"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigHost = process.env.ASPECTO_CONFIG_HOST ||
    (process.env.NODE_ENV !== 'aspc_dev' ? 'https://config.aspecto.io' : 'http://localhost:8085/');
var isNode_1 = require("./isNode");
exports.isNode = isNode_1.isNode;
exports.isValidUrl = (url) => {
    try {
        new URL(url);
        return true;
    }
    catch (e) {
        return false;
    }
};
exports.getCollectorEndpoint = (sendTrafficTo) => {
    let analyticsEndpoint = process.env.NODE_ENV !== 'aspc_dev' ? 'https://collector.aspecto.io/' : 'http://localhost:8084/';
    if (sendTrafficTo) {
        if (!exports.isValidUrl(sendTrafficTo)) {
            throw new Error(`${sendTrafficTo} is not a valid URL, no events will be sent.`);
        }
        analyticsEndpoint = sendTrafficTo;
    }
    return analyticsEndpoint;
};
//# sourceMappingURL=index.js.map