"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ReportCache {
    constructor(secondsInterval) {
        this.cache = {};
        this.interval = secondsInterval * 1000;
    }
    getReportCount(hostname) {
        var _a, _b, _c, _d, _e;
        // 1st encounter or passed interval, should report
        if (!this.cache[hostname] || Date.now() - ((_a = this.cache[hostname]) === null || _a === void 0 ? void 0 : _a.lastReportTimestamp) > this.interval) {
            const count = (_c = (_b = this.cache[hostname]) === null || _b === void 0 ? void 0 : _b.count, (_c !== null && _c !== void 0 ? _c : 0)) + 1;
            this.cache[hostname] = {
                lastReportTimestamp: Date.now(),
                count: 0,
            };
            return count;
        }
        else {
            this.cache[hostname].count = (_e = (_d = this.cache[hostname]) === null || _d === void 0 ? void 0 : _d.count, (_e !== null && _e !== void 0 ? _e : 0)) + 1;
            return 0;
        }
    }
}
exports.default = ReportCache;
//# sourceMappingURL=report-cache.js.map