"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const isUuid = (guid) => {
    const re = /^.*[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}.*$/i;
    return re.test(String(guid).toLowerCase());
};
const isMongoId = (id) => {
    const re = /^[0-9a-fA-F]{24}$/i;
    return re.test(String(id));
};
exports.findPatterns = (url) => {
    let patternsFound = 0;
    const patterns = {
        path: '',
        params: {},
    };
    url.split('/')
        .filter((x) => x && x !== '/')
        .forEach((val) => {
        if (isUuid(val) || isMongoId(val)) {
            const id = `param${patternsFound}`;
            patterns.params[id] = val;
            patterns.path = `${patterns.path}/:${id}`;
            patternsFound++;
        }
        else {
            patterns.path = `${patterns.path}/${val}`;
        }
    });
    return patterns;
};
//# sourceMappingURL=url-patterns.js.map