const fs = require('fs');
const child_process = require('child_process');

function createFile(id) {
    const data = { id: id.trim() };
    const dir = process.argv[2] || 'dist';
    const filePath = `${process.cwd()}/${dir}/id.json`;
    fs.writeFileSync(filePath, JSON.stringify(data));
    console.log(`Created Aspecto identifier ${id}`);
}

function create() {
    try {
        const rootPath = process.cwd() + '/';
        const rev = fs.readFileSync(`${rootPath}.git/HEAD`).toString();
        if (rev.indexOf(':') === -1) {
            createFile(rev);
        } else {
            const hash = readFileSync(`${rootPath}.git/${rev.substring(5).replace('\n', '')}`)
                .toString()
                .replace('\n', '');
            createFile(hash);
        }
        return;
    } catch (err) {}

    try {
        const gitData = child_process.execSync('git rev-parse HEAD', { stdio: 'ignore' }).toString();
        return createFile(gitData);
    } catch (err) {}

    try {
        const gitData = child_process.execSync('git rev-parse HEAD').toString();
        return createFile(gitData);
    } catch (err) {}

    try {
        createFile(`webapp-${new Date().toISOString()}`);
    } catch (err) {
        console.log('Failed generating aspecto identifier', err);
    }
}

create();
